/* Daytime client
 * RFC 867
 * 23.05.2005 Bernhard Rabe
 */
#include <sys/socket.h>
#include <unistd.h>
#include <sys/types.h>
#include <stdio.h>
#include <netdb.h>

int main(int argc, char *argv[])
{
	struct addrinfo hints, *conns;
	int ret;
	int  sock;
	char buf[256];
    char *service="daytime";
    
    if(argc<2)
    {
        fprintf(stderr,"usage: %s host [service|port]\n",argv[0]);
        exit(1);
    }
    if(argc>2)
        service=argv[2];
 
	bzero(&hints,sizeof(hints));
	hints.ai_family=AF_INET;
	hints.ai_socktype=SOCK_STREAM;
	hints.ai_protocol=IPPROTO_TCP;

    
    if((ret=getaddrinfo(argv[1],service,&hints,&conns)))
	{
        if(ret==EAI_SYSTEM) /*system vs gai_error*/
            perror("getaddrinfo");
        else
		    fprintf(stderr,"getaddrinfo:%s\n",gai_strerror(ret));
        exit(1);
	}
    /* try all connections */
	while(NULL!=conns)
	{
		struct sockaddr_in *conn;
		conn=(struct sockaddr_in*)conns->ai_addr;
		bzero(buf,256);

        if(-1==(sock=socket(AF_INET,SOCK_STREAM,IPPROTO_TCP)))
	    {
		    perror("socket");
            exit(1);
	    }
        
		printf("Addr: %s\n",inet_ntoa(conn->sin_addr));
		if(connect(sock,(struct sockaddr*)conn,sizeof(struct sockaddr)))
		{
			perror("No connection\n");
		}
		else
		{
			if(-1==recv(sock,buf,255,0))
			{
				perror("recv");
                exit(1);
			}
			printf("got: %s\n",buf); 
			if(-1==close(sock))
			{
				perror("recv");
                exit(1);
			}
		}

		conns=conns->ai_next;
	}
	
	freeaddrinfo(conns);

	return 0;
}