/* Daytime Server 
 * received data are handled by default
 * compile with -DWITHOUT_SELECT
 * see RFC 867 
 * 23.05.2005 Bernhard Rabe
 */

#include <sys/socket.h>
#include <unistd.h>
#include <sys/types.h>
#include <stdio.h>
#include <netdb.h>
#include <time.h>

int main(int argc, char *argv[])
{
	struct sockaddr_in addr; 
	int ret;
    u_short port;
	int sock;
	char buf[256];

    if(argc<2)
    {
        fprintf(stderr,"usage: %s port\n",argv[0]);
        exit(1);
    }
    
    port=atoi(argv[1]);
    
    addr.sin_family=AF_INET;
    addr.sin_port=htons(port);
    addr.sin_addr.s_addr=INADDR_ANY;
     
	if(-1==(sock=socket(AF_INET,SOCK_STREAM,IPPROTO_TCP)))
	{
        perror("socket");
        exit(1);
	}
    
    if(-1==bind(sock,(struct sockaddr*)&addr,sizeof(addr)))
    {
        perror("bind");
        exit(1);
    }
    
    if(-1==listen(sock,2))
    {
        perror("listen");
        exit(1);
    }
    
    while(1)
    {
        int client;
        int len;
        char buf[256];
        struct sockaddr_in cl;
#ifndef WITHOUT_SELECT            
        fd_set readfd;
        struct timeval tv={0,0};
#endif         
        time_t now;
        len=sizeof(cl);
       
        client=accept(sock,(struct sockaddr*)&cl,&len);
        if(-1==client)
        {
            perror("Error at accept");
            exit(1);
        }
        
#ifndef WITHOUT_SELECT       
        FD_ZERO(&readfd);
        FD_SET(client,&readfd);
        
        /*check for messages from client*/
        if(select(2,&readfd,NULL,NULL,&tv))
        {
            if(FD_ISSET(client,&readfd)) /* message is waiting */
                recv(client,buf,256,0); /*ignore message*/
        }
#endif        
        if((time_t)-1==time(&now))
            perror("time");
        
        if(NULL==ctime_r(&now,buf))
        {
            perror(NULL);
            exit(1);
        }
        printf("Connection from %s %d\n",inet_ntoa(cl.sin_addr),ntohs(cl.sin_port));
        printf("daytime %s\n",buf);
        if(strlen(buf)!=send(client,buf,strlen(buf),0))
        {
            perror("error sending to client");
        }
        if(-1==close(client))
        {
            perror("closesocket");
        }
    }
	return 0;
}
